//ModelesDeCouleurs_207d.js
// 28.11.12 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / <hsa@ringier.ch>
//DESCRIPTION:Crer des modles CMJN ou RVB

// activer l'affichage des dialogues
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// demander de slectionner le fichier ".csv" ou ".txt"...
var sourceFolder = new Folder("~/Documents/ModelesCouleurs");
var sourceFile   = File(sourceFolder).openDlg("Slectionner le fichier \".csv\" ou \".txt\":");
if (sourceFile  == null) {
	exit();
}

// ... et le lire
var numberString = "";
var f = File(sourceFile);
var fileIsOpen = f.open("r");
if (fileIsOpen) {
	try {
		numberString = f.read();
		f.close();
	}
	catch (e) {
		try {
			f.close();
		}
		catch (e) {
		}
	}
}
if (numberString == "") {
	alert ("Le fichier n'est pas lisible.", "Attention");
	exit();
}

// mmoriser le sparateur utilis
var sepType = "";
if (numberString.indexOf("\t") != -1) {
	sepType = "\t";
}
else if (numberString.indexOf(";") != -1) {
	sepType = ";";
}
if (sepType == "") {
	alert ("Il n'y a pas de sparateur valable (tab ou point-virgule).", "Stop");
	exit();
}

// mmoriser le marqueur de paragraphe utilis
var retType = "";
if (numberString.indexOf("\r") != -1) {
	retType = "\r";
}
else if (numberString.indexOf("\n") != -1) {
	retType = "\n";
}
else if (numberString.indexOf("\r\n") != -1) {
	retType = "\r\n";
}
if (retType == "") {
	alert ("Il n'y a pas de marqueur de paragraphe valable (Return, New Line).", "Stop");
	exit();
}

// mmoriser si CMJN ou RVB 
var colType = "";
var noType  = false;
if (numberString.indexOf("CMJN") != -1 || numberString.indexOf("CMYK") != -1) {
	colType = "CMYK";
}
else if (numberString.indexOf("RVB") != -1 || numberString.indexOf("RGB") != -1) {
	colType = "RGB";
}
if (colType == "") {
	noType = true;
	nParts = 0;
	// convertir la chane de texte en liste
	try {
		var testList   = numberString.split(retType);
		var testString = testList[1];
		var nParts = testString.split(sepType).length;
	}
	catch (e) {
	}
	if (nParts == 3) {
		colType = "RGB";
	}
	else if (nParts == 4) {
		colType = "CMYK";
	}
	else {
		alert ("CMJN ou RVB?\nImpossible de le dterminer.", "Stop");
		exit();
	}
}

// s'assurer que les valeurs RVB ne contiennent pas de positions aprs la virgule
if (colType == "RGB") {
	if (numberString.indexOf(",") != -1) {
		alert ("Des virgules ne sont pas admis\n(ni comme sparateur ni dans les valeurs RVB)", "Stop");
		exit();
	}
	else if (numberString.indexOf(".") != -1) {
		alert ("Des points ne sont pas admis\n(ni comme sparateur ni dans les valeurs RVB)", "Stop");
		exit();
	}
}

// mmoriser si le fichier contient des virgules
insCommas = false;
if (numberString.indexOf(",") != -1) {
	insCommas = true;
}

// supprimer des lignes vides ventuelles
objRegExp  = new RegExp(retType+retType, "g");
numberString = numberString.replace(objRegExp, "");

// supprimer un retour au dbut ventuel
if (numberString[0] == retType) {
	numberString = numberString.slice(1);
}

// supprimer un retour  la fin ventuel
if (numberString[numberString.length-1] == retType) {
	numberString = numberString.slice(0,-1);
}

// modifier les virgules en points
objRegExp  = new RegExp(",", "g");
numberString = numberString.replace(objRegExp, ".");

// convertir la chane de texte en liste
var numberList = numberString.split(retType);

if (noType == false) {
	// supprimer le premier lment de la liste (la ligne CMJN ou RVB)
	numberList.shift();
}

// convertir la liste en chane test
testString = numberList.join(sepType);
// supprimer les sparateurs...
objRegExp  = new RegExp(sepType, "g");
numbString = testString.replace(objRegExp, "");
// ... et les points
numbString = numbString.replace(/\./g, "");
// vrifier s'il n'y a que des chiffres
if (isNaN(numbString)) {
	alert ("Un caractre, au moins, n'est pas un chiffre.", "Stop");
	exit();
}

// mmoriser le nombre de nuances  crer
nColors = numberList.length;

// appeler la fonction qui lit les rglages enregistrs
var allPrefs = getPrefs();
if (allPrefs != "") {
	prefVal = allPrefs.split("\n");
	wVal = prefVal[0]*1;
	hVal = prefVal[1]*1;
	sVal = prefVal[2]*1;
	dVal = prefVal[3]*1;
	mVal = prefVal[4]*1;
	cVal = prefVal[5];
	rVal = prefVal[6];
	bVal = prefVal[7];
	rb01 = 1;
	rb02 = 0;
	if (bVal == "1") {
		rb01 = 0;
		rb02 = 1;
	}
	fVal = prefVal[8];
	rb03 = 1;
	rb04 = 0;
	if (fVal == "1") {
		rb03 = 0;
		rb04 = 1;
	}
	vVal = prefVal[9];
	rb05 = rb06 = rb07 = rb08 = 0;
	if (vVal == "0") {
		rb05 = 1;
	}
	else if (vVal == "1") {
		rb06 = 1;
	}
	else if (vVal == "2") {
		rb07 = 1;
	}
	else if (vVal == "3") {
		rb08 = 1;
	}
	nVal = prefVal[10]*1;
}
else {
	// lorsque le fichier des prfrences ne peut pas tre trouv, 
	// utiliser les valeurs par dfaut suivants
	wVal = 210;
	hVal = 297;
	sVal =   6;
	dVal =   1;
	mVal =   0;
	cVal =  "";
	rVal =  "";
	rb01 =   1;
	rb02 =   0;
	rb03 =   1;
	rb04 =   0;
	rb05 =   1;
	rb06 =   0;
	rb07 =   0;
	rb08 =   0;
	nVal =   0;
}

// dfinir "Jaune", "Noir" et "V" (ou "G")
if ((app.locale)*1 == 1279477362) { // InDesign en franais
	var yChar = "J";
	var kChar = "N";
	var gChar = "V";
}
else if ((app.locale)*1 == 1279477613) { // InDesign en allemand
	var yChar = "Y";
	var kChar = "K";
	var gChar = "G";
}
else if ((app.locale)*1 == 1279477102 || (app.locale)*1 == 1279477097) { // InDesign en anglais
	var yChar = "Y";
	var kChar = "K";
	var gChar = "G";
}
else {
	var yChar = "Y";
	var kChar = "K";
	var gChar = "G";
}

// tester s'il y a un document ouvert
var noDoc = false;
if (app.documents.length == 0) {
	noDoc = true;
}
else {
	// mmoriser le chemin du document
	var curDoc = app.documents[0];
	try {
		var docPath   = curDoc.fullName;
	}
	catch (e) {
		alert ("Enregistrer le document.", "Attention");
		exit();
	}
}

// appeler la fonction qui affiche le dialogue et convertit les valeurs
var anArray = displayDialog();
// mettre le rsultat aux variables
var wVal = anArray[0]*1;
var hVal = anArray[1]*1;
var sVal = anArray[2]*1;
var dVal = anArray[3]*1;
var mVal = anArray[4]*1;
var nCls = anArray[5];
var nRws = anArray[6];
var rDec = anArray[7]*1;
var sDec = anArray[8]*1;
var vDec = anArray[9]*1;
var nVal = anArray[10]*1;

// prparer les valeurs de rotation
var rotFrames = false;
if (nVal>0) {
	rotFrames = true;
	rotValues = new Array ();
	for (var r=(-nVal); r<(nVal+1); r++) {
		rotValues.push(r);
	}
}

// vrifier s'il y a un nombre de colonnes et/ou de ranges
if (nCls == "") { nCls = 0; }
else { nCls = nCls*1; }
if (nRws == "") { nRws = 0; }
else { nRws = nRws*1; }

if (noDoc == false) {
	// mmoriser les units de mesure
	// lorsque ce n'est pas 2053991795 (= millimtres), changer  millimtres
	hM = (curDoc.viewPreferences.horizontalMeasurementUnits)*1;
	vM = (curDoc.viewPreferences.verticalMeasurementUnits)*1;
	if (hM != 2053991795) {
		curDoc.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.millimeters;
	}
	if (vM != 2053991795) {
		curDoc.viewPreferences.verticalMeasurementUnits = MeasurementUnits.millimeters;
	}
	// modifier le point zro  zro/zro
	var zP = curDoc.zeroPoint; 
	if (zP != [0,0]) { 
		curDoc.zeroPoint = [0,0]; 
	}
	// mmoriser et modifier le point de rfrence si un angle de rotation est dfini
	if (rotFrames) {
		oldPoint = app.layoutWindows[0].transformReferencePoint;
		app.layoutWindows[0].transformReferencePoint = AnchorPoint.CENTER_ANCHOR;
	}
	// dverrouiller le calque actif (si ncessaire)
	var isLocked = false;
	var curLayer = app.activeWindow.activeLayer;
	if (curLayer.locked) {
		curLayer.locked = false;
		isLocked = true;
	}
	// mmoriser le format de la page
	var pWidth  = Math.round(curDoc.documentPreferences.pageWidth);
	var pHeight = Math.round(curDoc.documentPreferences.pageHeight);
	// calculer le nombre de blocs par range...
	var nHor = Math.floor((pWidth+dVal-mVal)/(sVal+dVal));
	// ... et par colonne
	var nVer = Math.floor((pHeight+dVal-mVal)/(sVal+dVal));
	// quand une valeur personnalise est souhaite
	if (nCls > 0) {
		if (nCls > nHor) {
			alert ("Seulement " + nHor + " colonnes sont possible.\n(et non " + nCls + ")", "Attention"); 
			resetAsBefore();
			exit();
		}
		else {
			var nHor = nCls;
		}
	}
	if (nRws > 0) {
		if (nRws > nVer) {
			alert ("Seulement " + nVer + " ranges sont possible.\n(et non " + nRws + ")", "Attention"); 
			resetAsBefore();
			exit();
		}
		else {
			var nVer = nRws;
		}
	}
	// vrifier le rsultat
	if (nHor < 1) {
		alert ("Nombre de colonnes = 0", "Stop");
		resetAsBefore();
		exit();
	}
	else if (nVer < 1) {
		alert ("Nombre de ranges = 0", "Stop");
		resetAsBefore();
		exit();
	}
	// le nombre de blocs par page
	var nPerPage = nHor*nVer;
	// le nombre de ranges
	var nRows = Math.ceil(nColors/nHor);
	// le nombre de colonnes
	var nCols = Math.ceil(nColors/nVer);
	// le nombre de pages
	var nPages = Math.ceil(nColors/nPerPage);
	if (nPages > 999) {
		var userDec = confirm ("Attention: " + nPages + " pages nont ncessaires. Continuer?");
	}
	if (userDec == false) {
		resetAsBefore();
		exit();
	}
	// insrer le nombre de pages ncessaires
	if (nPages>1) {
		for (var i=curDoc.pages.length; i<nPages; i++) {
			curDoc.pages.add();
		}
	}
	// enregistrer le document, le fermer...
	curDoc.close(SaveOptions.yes);
	// ... et l'ouvrir invisiblement
	curDoc = app.open(File(docPath), false);
}

if (noDoc) {
	// modifier le point de rfrence si un angle de rotation est dfini
	if (rotFrames) {
		// crer un document afin de pouvoir changer le point de rfrence
		curDoc = app.documents.add();
		// mmoriser  le point de rfrence
		oldPoint = app.layoutWindows[0].transformReferencePoint;
		// slectionner le point au centre
		app.layoutWindows[0].transformReferencePoint = AnchorPoint.CENTER_ANCHOR;
		// fermer le document
		curDoc.close();
	}
	// crer un document
	curDoc = app.documents.add(false, undefined);
	curDoc.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.millimeters;
	curDoc.viewPreferences.verticalMeasurementUnits = MeasurementUnits.millimeters;
	curDoc.documentPreferences.properties = {pageWidth:wVal, pageHeight:hVal, facingPages:false};
	with (curDoc.masterSpreads[0].pages.item(0).marginPreferences) {
		top=0;
		left=0;
		bottom=0;
		right=0;
	}
	// calculer le nombre de blocs par range...
	var nHor = Math.floor((wVal+dVal-mVal)/(sVal+dVal));
	// ... et par colonne
	var nVer = Math.floor((hVal+dVal-mVal)/(sVal+dVal));
	// quand une valeur personnalise est souhaite
	if (nCls > 0) {
		if (nCls > nHor) {
			alert ("Seulement " + nHor + " colonnes sont possible.\n(et non " + nCls + ")", "Attention"); 
			// fermer le document
			curDoc.close(SaveOptions.NO);
			exit();
		}
		else {
			var nHor = nCls;
		}
	}
	if (nRws > 0) {
		if (nRws > nVer) {
			alert ("Seulement " + nVer + " ranges sont possible.\n(et non " + nRws + ")", "Attention"); 
			curDoc.windows.add();
			// fermer le document
			curDoc.close(SaveOptions.NO);
			exit();
		}
		else {
			var nVer = nRws;
		}
	}
	// vrifier le rsultat
	if (nHor < 1) {
		alert ("Nombre de colonnes = 0", "Stop");
		// fermer le document
		curDoc.close(SaveOptions.NO);
		exit();
	}
	else if (nVer < 1) {
		alert ("Nombre de ranges = 0", "Stop");
		// fermer le document
		curDoc.close(SaveOptions.NO);
		exit();
	}
	// le nombre de blocs par page
	var nPerPage = nHor*nVer;
	// le nombre de ranges
	var nRows = Math.ceil(nColors/nHor);
	// le nombre de colonnes
	var nCols = Math.ceil(nColors/nVer);
	// le nombre de pages
	var nPages = Math.ceil(nColors/nPerPage);
	if (nPages > 999) {
		var userDec = confirm ("Attention: " + nPages + " pages nont ncessaires. Continuer?");
	}
	if (userDec == false) {
		// fermer le document
		curDoc.close(SaveOptions.NO);
		exit();
	}
	// insrer le nombre de pages ncessaires
	if (nPages>1) {
		for (var i=curDoc.pages.length; i<nPages; i++) {
			curDoc.pages.add();
		}
	}
}

// crer la liste des directions pour la spirale
// 1 = vers la droite; 2 = vers le haut; 3 = vers la gauche; 4 = vers le bas
if (vDec == 2) {
	var hDif = 0;
	var vDif = 0;
	if (nHor > nVer) {
		hDif = (nHor-nVer);
		if (hDif > 1) { 
			hDif = hDif-1;
		}
	}
	else {
		vDif = nVer-nHor;
		if (vDif > 1) { 
			vDif = vDif-1;
		}
	}
	var ctr = 0;
	if (nHor == nVer || hDif > 0) {
		var dirVal = 2;
	}
	else {
		var dirVal = 4;
	}
	var chgVal = 0;
	var dirValList = new Array ();
	dirValList.push(0);
	while (dirValList.length < nPerPage) {
		if (nHor == nVer || hDif > 0) {
			if (ctr%2 == 1) {
				chgVal++;
			}
		}
		else {
			if (ctr%2 == 0) {
				chgVal++;
			}
		}
		if (hDif == 0 && vDif == 0) {
			for (var x=0; x<chgVal; x++) {
				dirValList.push(dirVal);
				if (dirValList.length == nPerPage) {
					break;
				}
			}
		}
		else {
			if (hDif > 0) {
				if (dirVal == 1 || dirVal == 3) {
					for (var x=0; x<chgVal+hDif; x++) {
						dirValList.push(dirVal);
						if (dirValList.length == nPerPage) {
							break;
						}
					}
				}
				else {
					for (var x=0; x<chgVal; x++) {
						dirValList.push(dirVal);
						if (dirValList.length == nPerPage) {
							break;
						}
					}
				}
			}
			else if (vDif > 0) {
				if (dirVal == 2 || dirVal == 4) {
					for (var x=0; x<chgVal+vDif; x++) {
						dirValList.push(dirVal);
						if (dirValList.length == nPerPage) {
							break;
						}
					}
				}
				else {
					for (var x=0; x<chgVal; x++) {
						dirValList.push(dirVal);
						if (dirValList.length == nPerPage) {
							break;
						}
					}
				}
			}
		}
		dirVal++;
		if (dirVal > 4) {
			dirVal = 1;
		}
		ctr++;
	}
}

// prparer les valeurs "au hasard" (si c'est souhait)
if (vDec == 3) {
	var maxVal = nColors;
	// initialiser une liste
	var numArray = new Array ();
	// initialiser la chane de test
	var testString = "";
	// une boucle jusqu' ce que le compte est bon
	while (numArray.length < maxVal) {
		var okay = true;
		// une boucle intrieure
		while (okay == true) {
			okay = false;
			// gnrer une valeur au hasard
			num = Math.floor(Math.random()*maxVal); // de 0  maxVal-1
			// placer des "|" devant et derrire
			var testNumber = "|" + num + "|";
			// tester si la valeur se trouve dans la liste
			if (testString.indexOf(testNumber) == -1) {
				// ajouter la valeur actuelle  la liste 
				numArray.push(num);
				// actualiser la chane de test
				testString = "|" + (numArray.join("|")) + "|";
				// si 'okay', quitter la boucle
				okay = true;
			}
		}
	}
}

// prparer les valeurs des positions de dpart et des dcalages
var yOff = sVal+dVal;
var xOff = sVal+dVal;

// crer les nuances et les blocs de la range (ou colonne) actuelle
var ctr = 0;
var p   = -1;
var rcCtr  = 0;
var rotVal = 0;
for (var i=0; i<nColors; i++) {
	if (i%nPerPage == 0) {
		p++;
		if (rDec == 0) {
			if (vDec != 2) {
				var y1 = mVal-yOff;
				if (vDec == 0) {
					var x1 = mVal;
				}
				else {
					if (i>1) {
						if (rcCtr%2 == 0) {
							x1 = mVal;
						}
						else {
							x1 = x1;
						}
					}
					else {
						x1 = mVal;
					}
				}
			}
		}
		else {
			if (vDec != 2) {
				var x1 = mVal-xOff;
				if (vDec == 0) {
					var y1 = mVal;
				}
				else {
					if (i>1) {
						if (rcCtr%2 == 0) {
							y1 = mVal;
						}
						else {
							y1 = y1;
						}
					}
					else {
						y1 = mVal;
					}
				}
			}
		}
	}
	if (vDec == 2 && rDec == 1) {
		var curCol = (numberList[(nColors-1)-i]).split(sepType);
	}
	else if (vDec == 3) {
		var x = numArray[i];
		var curCol = (numberList[x]).split(sepType);
	}
	else {
		var curCol = (numberList[i]).split(sepType);
	}
	if (colType == "CMYK") {
		c = curCol[0]*1;
		m = curCol[1]*1;
		y = curCol[2]*1;
		k = curCol[3]*1;
		var valTest = testCMYKvalues(c,m,y,k);
		if (valTest == "no good") {
			// alerter...
			alert ("La ligne " + (i+1) + " n'a pas *quatre* valeurs.", "Stop");
			// rendre le document visible...
			curDoc.windows.add();
			// ... restaurer les prfrences...
			resetAsBefore();
			// ... et arrter l'excution
			exit();
		}
		var curValues = [c,m,y,k];
		var testName  = "C=" + c + " M=" + m + " " + yChar + "=" + y + " " + kChar + "=" + k;
		// lorsque le fichier texte contient des virgules
		if (insCommas) {
			// remplacer des points ventuels par des points
			testName = testName.replace(/\./g, ",");
		}
		try {
			testColor = curDoc.colors.itemByName(testName).name;
			curColor  = curDoc.colors.itemByName(testName);
		}
		catch (e) {
			curColor  = curDoc.colors.add({space:ColorSpace.CMYK, colorValue:curValues, name:testName});
		}
	}
	else {
		r = curCol[0]*1;
		g = curCol[1]*1;
		b = curCol[2]*1;
		var valTest = testRGBvalues(r,g,b);
		if (valTest == "no good") {
			// alerter ...
			alert ("La ligne " + (i+1) + " n'a pas *trois* valeurs.", "Stop");
			// rendre le document visible...
			curDoc.windows.add();
			// ... restaurer les prfrences...
			resetAsBefore();
			// ... et arrter l'excution
			exit();
		}
		var curValues = [r,g,b];
		var testName  = "R=" + r + " " + gChar + "=" + g + " B=" + b;
		try {
			testColor = curDoc.colors.itemByName(testName).name;
			curColor  = curDoc.colors.itemByName(testName);
		}
		catch (e) {
			curColor  = curDoc.colors.add({space:ColorSpace.RGB, colorValue:curValues});
		}
	}

	// l'tiquette du bloc
	if (vDec == 2 && rDec == 1) {
		var curLabel = "" + ((nColors)-i);
	}
	else if (vDec == 3) {
		var curLabel = "" + (numArray[i]+1);
	}
	else {
		var curLabel = "" + (i+1);
	}
	
	// l'angle de rotation actuel
	if (rotFrames) {
		num = Math.floor(Math.random()*rotValues.length);
		rotVal = rotValues[num];
	}
	
	if (rDec == 0) { // lors d'une construction horizontale
		if (i%nHor == 0) {
			if (vDec != 2) {
				// augmenter la position Y par la valeur de dcalage
				y1 = y1+yOff;
				if (vDec == 0) {
					x1 = mVal;
				}
				else {
					if (i>1) {
						if (rcCtr%2 == 0) {
							x1 = mVal;
						}
						else {
							x1 = x1-xOff;
						}
					}
				}
			}
			rcCtr++;
		}
		if (vDec == 2) { // lors d'une construction en spirale
			if (i == 0 || i%nPerPage == 0) {
				y1 = mVal + ((Math.floor(nVer/2))*yOff);
				x1 = mVal + ((Math.floor(nHor/2))*xOff);
				if (hDif == 0 && vDif == 0) {
					if (nVer%2 == 0) {
						y1 = y1 - yOff;
					}
				}
				if (hDif != 0) {
					if (nVer%2 == 0) {
						y1 = y1-yOff;
					}
				}
				if (vDif != 0) {
					y1 = y1 - ((Math.floor((vDif-1)/2))*yOff)-yOff;
					if (nVer%2 == 0) {
						if (vDif>1 && nHor%2 == 1) {
							y1 = y1 - yOff;
						}
					}
				}
				if (hDif != 0) {
					if (nHor%2 == 0) {
						x1 = x1 + (Math.ceil((hDif-1)/2))*xOff;
					}
					else {
						x1 = x1 + (Math.ceil(hDif/2))*xOff;
					}
				}
				if (vDif != 0) {
					if (nHor%2 == 0) {	
						x1 = x1 + ((Math.ceil((hDif-1)/2))*xOff)-xOff;
					}
					else {
						x1 = x1 + (Math.ceil(hDif/2))*xOff;
					}
				}
				var ctr = 1;
			}
			else {
				curDir = dirValList[ctr];
				if (curDir == 1) {
					x1 = x1+xOff;
				}
				else if (curDir == 2) {
					y1 = y1-yOff;
				}
				else if (curDir == 3) {
					x1 = x1-xOff;
				}
				else if (curDir == 4) {
					y1 = y1+yOff;
				}
				ctr++;
			}
		}
		// crer le bloc actuel
		if (sDec == 0) {
			curDoc.pages[p].rectangles.add({geometricBounds:[y1,x1,y1+sVal,x1+sVal], fillColor:curColor, fillTint:100, strokeColor:"None", label:curLabel, rotationAngle:rotVal});
		}
		else {
			curDoc.pages[p].ovals.add({geometricBounds:[y1,x1,y1+sVal,x1+sVal], fillColor:curColor, fillTint:100, strokeColor:"None", label:curLabel});
		}
		if (vDec == 2) {
			// ne faire plus rien
		}
		else if (vDec == 0 || rcCtr == 0) {
			// augmenter la position X par la valeur de dcalage
			x1 = x1+xOff;
		}
		else {
			if (rcCtr%2 == 0) {
				// diminuer la position X par la valeur de dcalage
				x1 = x1-xOff;
			}
			else {
				x1 = x1+xOff;
			}
		}
	}
	else { // lors d'une construction verticale
		if (i%nVer == 0) {
			if (vDec != 2) {
				// augmenter la position X par la valeur de dcalage
				x1 = x1+xOff;
				if (vDec == 0) {
					y1 = mVal;
				}
				else {
					if (i>1) {
						if (rcCtr%2 == 0) {
							y1 = mVal;
						}
						else {
							y1 = y1-yOff;
						}
					}
				}
			}
			rcCtr++;
		}
		if (vDec == 2) { // lors d'une construction en spirale
			if (i == 0 || i%nPerPage == 0) {
				y1 = mVal + ((Math.floor(nVer/2))*yOff);
				x1 = mVal + ((Math.floor(nHor/2))*xOff);
				if (hDif == 0 && vDif == 0) {
					if (nVer%2 == 0) {
						y1 = y1 - yOff;
					}
				}
				if (hDif != 0) {
					if (nVer%2 == 0) {
						y1 = y1-yOff;
					}
				}
				if (vDif != 0) {
					y1 = y1 - ((Math.floor((vDif-1)/2))*yOff)-yOff;
					if (nVer%2 == 0) {
						if (vDif>1 && nHor%2 == 1) {
							y1 = y1 - yOff;
						}
					}
				}
				if (hDif != 0) {
					if (nHor%2 == 0) {	
						x1 = x1 + (Math.ceil((hDif-1)/2))*xOff;
					}
					else {
						x1 = x1 + (Math.ceil(hDif/2))*xOff;
					}
				}
				if (vDif != 0) {
					if (nHor%2 == 0) {	
						x1 = x1 + ((Math.ceil((hDif-1)/2))*xOff)-xOff;
					}
					else {
						x1 = x1 + (Math.ceil(hDif/2))*xOff;
					}
				}
				var ctr = 1;
			}
			else {
				curDir = dirValList[ctr];
				if (curDir == 1) {
					x1 = x1+xOff;
				}
				else if (curDir == 2) {
					y1 = y1-yOff;
				}
				else if (curDir == 3) {
					x1 = x1-xOff;
				}
				else if (curDir == 4) {
					y1 = y1+yOff;
				}
				ctr++;
			}
		}
		// crer le bloc actuel
		if (sDec == 0) {
			curDoc.pages[p].rectangles.add({geometricBounds:[y1,x1,y1+sVal,x1+sVal], fillColor:curColor, fillTint:100, strokeColor:"None", label:curLabel, rotationAngle:rotVal});
		}
		else {
			curDoc.pages[p].ovals.add({geometricBounds:[y1,x1,y1+sVal,x1+sVal], fillColor:curColor, fillTint:100, strokeColor:"None", label:curLabel});
		}
		if (vDec == 2) {
			// ne faire plus rien
		}
		else if (vDec == 0 || rcCtr == 0) {
			// augmenter la position Y par la valeur de dcalage
			y1 = y1+yOff;
		}
		else {
			if (rcCtr%2 == 0) {
				// diminuer la position Y par la valeur de dcalage
				y1 = y1-yOff;
			}
			else {
				y1 = y1+yOff;
			}
		}
	}
}
// rendre le document visible...
curDoc.windows.add();
// ... et afficher la premire page
app.activeWindow.activePage = curDoc.pages[0];

// rtablir le point de rfrence
if (rotFrames) {
	app.layoutWindows[0].transformReferencePoint = oldPoint;
}

// appeler la fonction pour rtablir les rglages initiales
resetAsBefore();


////////////////////////////// les fonctions  /////////////////////////////////////////////////////

// la fonction qui prpare les informations ///////////////////////////////////////////////////////
function getPrefs() {
	var allPrefs = "";
	// lire le fichier contenant les valeurs enregistres
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/modelescouleurs207.txt");
	}
	else {
		var f = new File("~/Library/Preferences/modelescouleurs207.txt");
	}
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			allPrefs = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return allPrefs;
}

// prparer et afficher le dialogue ///////////////////////////////////////////////////////////////
function displayDialog() {
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	var labelWidth1 = 200;
	var labelWidth2 =  92;
	var labelWidth3 = 175;
	var labelWidth4 = 106;
	var fieldWidth  =  32;
	var aDialog = app.dialogs.add({name:"ModelesDeCouleurs"});
	with (aDialog) {
		with (dialogColumns.add()) {
			if (noDoc) {
				with (dialogRows.add()) {
					with (borderPanels.add()) {
						with (dialogColumns.add()) {
							with (dialogRows.add()) {
								staticTexts.add({staticLabel:"Crer un nouveau document:"});
								staticTexts.add({staticLabel:" ", minWidth:4});
							}
							with (dialogRows.add()) {
								staticTexts.add({staticLabel:"Largeur:", minWidth:labelWidth1});
								var widthField = realEditboxes.add({editValue:wVal, minimumValue:30, maximumValue:1000, minWidth:fieldWidth});
								staticTexts.add({staticLabel:"mm"});
							}
							with (dialogRows.add()) {
								staticTexts.add({staticLabel:"Hauteur:", minWidth:labelWidth1});
								var heightField = realEditboxes.add({editValue:hVal, minimumValue:30, maximumValue:1000, minWidth:fieldWidth});
								staticTexts.add({staticLabel:"mm"});
							}
						}
					}
				}
			}
			with (dialogRows.add()) {
				with (borderPanels.add()) {
					with (dialogColumns.add()) {
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"Les valeurs pour les blocs et les espaces:"});
						}
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"Largeur et hauteur des blocs:", minWidth:labelWidth1});
							var sizeField = realEditboxes.add({editValue:sVal, minimumValue:1, maximumValue:25, minWidth:fieldWidth});
							staticTexts.add({staticLabel:"mm"});
						}
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"Espacer colonnes et ranges:", minWidth:labelWidth1});
							var guttField = realEditboxes.add({editValue:dVal, minimumValue:-10, maximumValue:10, minWidth:fieldWidth});
							staticTexts.add({staticLabel:"mm"});
						}
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"La distance au bord de la page:", minWidth:labelWidth1});
							var distField = realEditboxes.add({editValue:mVal, minimumValue:0, maximumValue:10, minWidth:fieldWidth});
							staticTexts.add({staticLabel:"mm"});
						}
					}
				}
			}
			with (dialogRows.add()) {
				with (borderPanels.add()) {
					with (dialogColumns.add()) {
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"Les colonnes et les ranges par page:"});
							staticTexts.add({staticLabel:" ", minWidth:25});
						}
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"Le nombre de colonnes:", minWidth:labelWidth1});
							var colsField = textEditboxes.add({editContents:cVal, minWidth:fieldWidth});
						}
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"Le nombre de ranges:", minWidth:labelWidth1});
							var rowsField = textEditboxes.add({editContents:rVal, minWidth:fieldWidth});
						}
					}
				}
			}
			with (dialogRows.add()) {
				with (borderPanels.add()) {
					with (dialogColumns.add()) {
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"La direction: ", minWidth:labelWidth2});
							with (refButtons = radiobuttonGroups.add()) {
								radiobuttonControls.add({staticLabel:"construction horizontale", checkedState:rb01, minWidth:labelWidth3});
								radiobuttonControls.add({staticLabel:"construction verticale", checkedState:rb02});
							}
						}
					}
				}
			}
			with (dialogRows.add()) {
				with (borderPanels.add()) {
					with (dialogColumns.add()) {
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"La forme: ", minWidth:labelWidth2});
							with (shpButtons = radiobuttonGroups.add()) {
								radiobuttonControls.add({staticLabel:"un carr", checkedState:rb03, minWidth:labelWidth3});
								radiobuttonControls.add({staticLabel:"un cercle", checkedState:rb04});
							}
						}
					}
				}
			}
			with (dialogRows.add()) {
				with (borderPanels.add()) {
					with (dialogColumns.add()) {
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"Variations: ", minWidth:labelWidth2});
							with (varButtons = radiobuttonGroups.add()) {
								radiobuttonControls.add({staticLabel:"aucune", checkedState:rb05, minWidth:labelWidth3});
								radiobuttonControls.add({staticLabel:"boustrophdon", checkedState:rb06});
								radiobuttonControls.add({staticLabel:"en spirale", checkedState:rb07});
								radiobuttonControls.add({staticLabel:"ordre au hasard", checkedState:rb08});
							}
						}
					}
				}
			}
			with (dialogRows.add()) {
				with (borderPanels.add()) {
					with (dialogColumns.add()) {
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"Angle de rotation au hasard:"});
							staticTexts.add({staticLabel:" ", minWidth:82});
						}
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"plus/moins:", minWidth:labelWidth1});
							var rotaField = realEditboxes.add({editValue:nVal, minimumValue:0, maximumValue:10, minWidth:fieldWidth});
							staticTexts.add({staticLabel:"    "});
						}
					}
				}
			}
		}
	}
	if(aDialog.show() == true) {
		if (noDoc) {
			var wdthVal = widthField.editValue;
			var hghtVal = heightField.editValue;
		}
		else {
			var wdthVal = wVal;
			var hghtVal = hVal;
		}
		var sizeVal = sizeField.editValue;
		var guttVal = guttField.editValue;
		var distVal = distField.editValue;
		var rowsVal = rowsField.editContents;
		var colsVal = colsField.editContents;
		var refDec  = refButtons.selectedButton;
		var shpDec  = shpButtons.selectedButton;
		var varDec  = varButtons.selectedButton;
		var rotVal  = rotaField.editValue;
		// supprimer le dialogue
		aDialog.destroy();
		// la liste des rglages...
		var prefsList = new Array (wdthVal, hghtVal, sizeVal, guttVal, distVal, colsVal, rowsVal, refDec, shpDec, varDec, rotVal);
		// ... la transformer en chane de texte...
		var prefString = prefsList.join("\n");
		// ... et l'envoyer  la fonction qui l'crit dans un fichier
		writeResult(prefString);
		// passer le choix de l'utilisateur aux variables
		if (noDoc) {
			wVal = wdthVal;
			hVal = hghtVal;
		}
		// vrifier les valeurs pour les colonnes et les ranges
		if (colsVal != "") {
			testCols = parseInt(colsVal);
			if (isNaN(testCols)) {
				alert (colsVal + " n'est pas un nombre.", "Stop");
				exit();
			}
			else if (testCols < 1) {
				testCols = "";
			}
		}
		else {
			testCols = "";
		}
		if (rowsVal != "") {
			testRows = parseInt(rowsVal);
			if (isNaN(testRows)) {
				alert (rowsVal + " n'est pas un nombre.", "Stop");
				exit();
			}
			else if (testRows < 1) {
				testRows = "";
			}
		}
		else {
			testRows = "";
		}
		return [wdthVal, hghtVal, sizeVal, guttVal, distVal, testCols, testRows, refDec, shpDec, varDec, rotVal, cb01];
	}
	else {
		aDialog.destroy();
		exit();
	}
}

// rtablir les rglages initiales ////////////////////////////////////////////////////////////////
function resetAsBefore() {
	if (noDoc == false) {
		// rtablir le point zro (si ncessaire) 
		if (zP != [0,0]) { 
			curDoc.zeroPoint = zP; 
		}
		// rtablir les units de mesure (si ncessaire)
		if (hM != 2053991795) {
			curDoc.viewPreferences.horizontalMeasurementUnits = hM;
		}
		if (vM != 2053991795) {
			curDoc.viewPreferences.verticalMeasurementUnits = vM;
		}
		// verrouiller le calque (si ncessaire)
		if (isLocked) {
			curLayer.locked = true;
		}
	}
}

// crire le rsultat dans un fichier /////////////////////////////////////////////////////////////
function writeResult(curPrefs) {
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/modelescouleurs207.txt");
	}
	else {
		var f = File("~/Library/Preferences/modelescouleurs207.txt");
	}
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(curPrefs);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
}

// tester les valeurs CMJN
function testCMYKvalues(c,m,y,k) {
	if (c>100) {
		alert ("C: " + c + " ?!?\nPas de valeurs farfelues, svp.", "Stop");
		curDoc.windows.add();
		resetAsBefore();
		exit();
	}
	else if (m>100) {
		alert ("M: " + m + " ?!?\nPas de valeurs farfelues, svp.", "Stop");
		curDoc.windows.add();
		resetAsBefore();
		exit();
	}
	else if (y>100) {
		alert (yChar + ": " + y + " ?!?\nPas de valeurs farfelues, svp.", "Stop");
		curDoc.windows.add();
		resetAsBefore();
		exit();
	}
	else if (k>100) {
		alert (kChar + ": " + k + " ?!?\nPas de valeurs farfelues, svp.", "Stop");
		curDoc.windows.add();
		resetAsBefore();
		exit();
	}
	else if (isNaN(k)) {
		return "no good";
	}
	return "okay";
}

// tester les valeurs RVB
function testRGBvalues(r,g,b) {
	if (r>255) {
		alert ("R: " + r + " ?!?\nPas de valeurs farfelues, svp.", "Stop");
		curDoc.windows.add();
		resetAsBefore();
		exit();
	}
	else if (g>255) {
		alert (gChar + ": " + g + " ?!?\nPas de valeurs farfelues, svp.", "Stop");
		curDoc.windows.add();
		resetAsBefore();
		exit();
	}
	else if (b>255) {
		alert ("B: " + b + " ?!?\nPas de valeurs farfelues, svp.", "Stop");
		curDoc.windows.add();
		resetAsBefore();
		exit();
	}
	else if (isNaN(b)) {
		return "no good";
	}
	return "okay";
}